var name = '',mediaName='', theatreTime=0, season='';
function search(){
	getProgramAnalysisList(1);
    getRankList();
}

/**
 * 获取与验证对标对象
 */
function itemCheck(o){
	var item = $("input[name='item']:checked"), ids = [];
	if(item.length > 3){
		alert("最多选择三部电视剧");
		$(o).attr("checked", false);
		$.checkbox();
		return false;
	}

	var errorMsg = "";
	item.each(function(){
		var id = $(this).attr('data-tvid');
		if (id.isEmpty() || id == 0){
			errorMsg = "当前剧在剧库中不存在";
			return false;
		}
		ids.push(id);
	});
	if (!errorMsg.isEmpty()){
		alert(errorMsg);
		$(o).attr("checked", false);
		$.checkbox();
		return false;
	}

	if((new Set(ids)).size != ids.length){
		alert("已存在，请选择不同的电视剧");
		$(o).attr("checked", false);
		$.checkbox();
		return false;
	}
}

/**
 * 打开对标页
 * @returns {Boolean}
 */
function setBenchmark(){
	var item = $("input[name='item']:checked"), ids = [];
	if (item.length <= 0){
		alert("请至少选择一部电视剧");
		return false;
	}
	if (item.length > 3){
		alert("最多选择三部电视剧");
		return false;
	}
	var errorMsg = "";
	item.each(function(index){
		var id = $(this).attr('data-tvid');
		if (id.isEmpty() || id == 0){
			errorMsg = "第 " + (index+1) + " 项在剧库中不存在";
			return false;
		}
		ids.push(id);
	});
	if (!errorMsg.isEmpty()){
		alert(errorMsg);
		return false;
	}
	if((new Set(ids)).size != ids.length){
		alert("已存在，请选择不同的电视剧");
		return false;
	}
	window.open("benchmarking.do?ids="+encodeURIComponent(ids.join(",")),"new");
}

/**
 * 切换时间
 */
function changeTab(day){
	var end_date = '', start_date = '';
	if(day > 0){
		end_date = new Date().addDate(-1).Format("yyyy-MM-dd"),
		start_date = new Date(end_date).addDate(-day).Format("yyyy-MM-dd");
		$('#start_time').val(start_date);
		$('#end_time').val(end_date);
	}else{
		$('#start_time').val('');
		$('#end_time').val('');
	}
	$(".text").input();
	search();
}

/**
 * 切换节目
 * @param program
 */
function changeProgram(program){
	getPlacementDetail();
}

/**
* 搜索后，点击一个后的所有图标展示
*/
function getPlacementDetail(){
	changeTagName();
	getPlacementDetailList(1);
	// 电视剧收视分析
	getTvTrendChart();
	// 电视剧收视区域分布
	getZoneNumChart();
	// 电视剧产品投放分析
	getProductChart();
	// 电视剧题材分析
	getThemeChart();
}


function getProgramAnalysisList(page){
	page = page || 1;
	var pageSize = "10", data = {
		"name": $("#keyword").val(),
		"mediaName":$("#mediaName").val(),
		"firstTheme":$("#firstTheme").val(),
		"secondTheme":$("#secondTheme").val(),
		"theatreTime":$("#theatreTime").val(),
		"channelSystem":$("#mediaRank").val(),
		"startDate": $("#start_time").val(),
		"endDate": $("#end_time").val(),
		"pageNo": page,
		"pageSize": pageSize
	}, html = "";
	$("#program_analysis_page, #program_analysis_list").empty();
	ajax("ajax_list.do",data,function(res){
		if(res.code == 1 && res.data.records.length > 0){
			$.each(res.data.records, function(index, item){
				html += "<tr data-name='"+item.name+"' data-medianame='"+item.mediaName+"' data-theatretime='"+item.theatreTime+"' data-season='"+(item.season)+"'>"+
					"<td>"+$.orderNum(page,pageSize,index)+"</td>"+
					"<td>"+item.name+"</td>"+
					"<td>"+item.mediaName+"</td>"+
					"<td>"+item.firstTheme+"</td>"+
					"<td>"+item.secondTheme+"</td>"+
					"<td>"+item.theatreTimeName+"</td>"+
					"<td>"+item.channelSystem+"</td>"+
					"<td>"+item.season+"</td>"+
					"<td>"+item.tvNum+"</td>"+
					"<td>"+((item.rating29==undefined)?"":item.rating29)+"</td>"+
					"<td>"+((item.dk29==undefined)?"":item.dk29)+"</td>"+
					"<td>"+item.mediaRating29+"</td>"+
					"<td>"+item.mediaDk29+"</td>"+
					"<td>"+item.effect+"</td>"+
					"<td><input type='checkbox' class='checkbox {click:itemCheck}' name='item' data-tvid='"+item.tvId+"' value='"+item.name+"' /><label></label></td>"+
				"</tr>";
			});
			$("#program_analysis_list").html(html);
			$.checkbox();
			$.radio();
			var newpage = new createPage(res.data.total,page,pageSize,3,"getProgramAnalysisList");
			$("#program_analysis_page").html(newpage.pageHtml);
			$('#program_analysis_count').html(res.data.total);
		
			$(".table").hoverTable(true, true);
			/**
			 * 点击事件
			 */
			$("#program_analysis_list>tr>td:not(td:last-child)").on("click",function(){
			    name = $(this).closest("tr").data("name");
			    mediaName = $(this).closest("tr").data("medianame");
			    theatreTime = $(this).closest("tr").data("theatretime");
			    season = $(this).closest("tr").data("season");

			    $("#name_1").val(name);
			    $("#mediaName_1").val(mediaName);
			    $("#theatreTime_1").val(theatreTime);
			    $("#season_1").val(season);
			    $("#start_time_1").val($("#start_time").val());
			    $("#end_time_1").val($("#end_time").val());

                getPlacementDetail();
				$(this).closest("tr").addClass("active").siblings().removeClass("active");
				// 电视剧及卫视剧场排名  高亮
				activeTvRank(name, mediaName);
			});
			$("#program_analysis_list>tr:eq(0)>td:eq(1)").click();


		}else{
		    $("#placement_detail_list").info("暂无数据。");
        	$('#placement_detail_count').html(0);

			$("#trend_bar, #people_bar").info("暂无数据。", true);
			$("#tvNum_bar, #mediaNum_bar").info("暂无数据。", true);
			$("#product_time_pie").info("暂无数据。", true);
			$("#product_freq_pie").info("暂无数据。", true);

			$("#tvTheme_pie").info("暂无数据。", true);
			$("#mediaTheme_pie").info("暂无数据。", true);
			$('#program_analysis_count').html(0);
			name = '';
			mediaName = '';
            changeTagName();
		}
	});
}

/**
 * 电视剧及卫视剧场排名  高亮
 * @param name 剧名
 * @param mediaName 媒体名
 */
function activeTvRank(name, mediaName) {
	// 剧场电视剧收视排名
	$("#rank_char_1").find("tr").each(function(){
		var temp_name = $(this).attr('data-name');
		var temp_mediaName = $(this).attr('data-mediaName');
		$(this).removeClass("active");
		if (name == temp_name && mediaName == temp_mediaName){
			$(this).addClass("active");
		}
	});
	$("#rank_char_2").find("tr").each(function(){
		var temp_mediaName = $(this).attr('data-mediaName');
		$(this).removeClass("active");
		if (mediaName == temp_mediaName){
			$(this).addClass("active");
		}
	});
}

function getPlacementDetailList(page){
	page = page || 1;
	var pageSize = "10",beginDate = $("#start_time").val(),
		endDate = $("#end_time").val(),data = {
		"pageNo": page,
		"pageSize": pageSize,
		"name":name,
		"mediaName" : mediaName,
		"theatreTime": theatreTime,
		"season": season,
		"startDate": beginDate,
		"endDate": endDate
	}, html = "";
	$("#placement_detail_page, #placement_detail_list").empty();
	ajax("ajax_detail_list.do",data,function(res){
		if(res.code == 1 && res.data.records.length > 0){
			$.each(res.data.records, function(index, item){

				html += "<tr>"+
					"<td>"+$.orderNum(page,pageSize,index)+"</td>"+
					"<td>"+item.name+"</td>"+
					"<td>"+item.mediaName+"</td>"+
					"<td>"+item.firstTheme+"</td>"+
					"<td>"+item.secondTheme+"</td>"+
					"<td>"+item.mediaNum+"</td>"+
					"<td>"+item.showDate+"</td>"+
					"<td>"+item.showTime+"</td>"+
					"<td>"+
					((item.productName==undefined)?"":
					(ztgg_analysis == 1 ? '<a class="blue" href="'+ _PUBLIC_ +'special_analysis/index.do?type='+item.type+'&keyword='+item.productName+'">'+item.productName+'</a>'
						: '<a class="blue" href="javascript:alert(\'您暂无权限，请联系管理员。\');">'+item.productName+'</a>' ) )+
					"</td>"+
					"<td>"+item.showDuration +"</td>"+
					"<td>"+((item.jinxian==undefined)?"":item.jinxian)+"</td>"+
					"<td>"+((item.rating29==undefined)?"":item.rating29)+"</td>"+
					"<td>"+((item.dk29==undefined)?"":item.dk29)+"</td>"+
					"<td>"+((item.rating51==undefined)?"":item.rating51) +"</td>"+
					"<td>"+((item.dk51==undefined)?"":item.dk51)+"</td>";
				html += "</tr>";
			});
			$("#placement_detail_list").html(html);
			$(".table").hoverTable(true, true);
			var newpage = new createPage(res.data.total,page,pageSize,3,"getPlacementDetailList");
			$("#placement_detail_page").html(newpage.pageHtml);
			$('#placement_detail_count').html(res.data.total);
			/**
			 * 点击事件
			 */
			$(".table").hoverTable(true, true);
		}else{
			$("#placement_detail_list").info("暂无数据。");
			$('#placement_detail_count').html(0);
		}
	});
}

placementDetailPageGo = getPlacementDetailList;

/**
 * 电视剧收视分析
 */
function getTvTrendChart(){
	var data = {
			"name" : name,
			"mediaName": mediaName,
			"startDate": $("#start_time").val(),
			"endDate": $("#end_time").val(),
			"theatreTime" : theatreTime
		};
	ajax("ajax_tv_ratio.do",data,function(res){
		if(res.code == 1 && res.data.trendVOS.length > 0){
			var xdata = [],ydata = [],platforms = [],html = "";
			$.each(res.data.trendVOS, function(index, item){
					xdata.push(item.showDate);ydata.push(item.ratio);
			});
			trendBar('收视率','收视趋势分析',xdata,ydata,'trend_bar');

            xdata = [],ydata = [];
			$.each(res.data.peopleVOS, function(index, item){
                    xdata.push(item.type);ydata.push(item.ratio);
            });
            trendBar('比例%','人群构成',xdata,ydata,'people_bar');
			
		}else{
			$("#trend_bar").info("暂无数据。",true);
			$("#people_bar").html('');
		}
	},false);
}


/**
 * 电视剧收视区域分布
 */
function getZoneNumChart(){
	var data = {
			"name" : name,
			"mediaName": mediaName,
			"startDate": $("#start_time").val(),
			"endDate": $("#end_time").val(),
			"theatreTime" : theatreTime
		};
	ajax("ajax_tv_zone.do",data,function(res){
		if(res.code == 1 && res.data.tvNum.length > 0){
			var xdata = [],ydata = [],platforms = [],html = "";
			$.each(res.data.tvNum, function(index, item){
					xdata.push(item.province);ydata.push(item.num);
			});
			trendBar('触达千人','触达千人',xdata,ydata,'tvNum_bar');

            xdata = [],ydata = [];
			$.each(res.data.mediaNum, function(index, item){
                    xdata.push(item.province);ydata.push(item.num);
            });
            trendBar('触达千人','平均触达千人',xdata,ydata,'mediaNum_bar');

		}else{
			$("#tvNum_bar").info("暂无数据。",true);
			$("#mediaNum_bar").html('');
		}
	},false);
}

/**
 * 电视剧产品投放分析
 */
function getProductChart(){
	var data = {
			"name" : name,
            "mediaName": mediaName,
            "startDate": $("#start_time").val(),
            "endDate": $("#end_time").val(),
            "theatreTime" : theatreTime
		};
	ajax("ajax_tv_product.do",data,function(res){
		if(res.code == 1 && res.data.length > 0){
			var legend= [], series = [],xdata = [],ydata = [];
			var xOther = 0, yOther = 0;

			data1 = res.data.sort(function(a,b){
                return b.duration-a.duration;
            });

			$.each(data1, function(index, item){
				if (index >= 10){
					yOther += item.duration;
					return true;
				}
			    legend.push(item.name);
                // 时长
                var lv2 = {
                    value: item.duration,
                    name : item.name
                };
                ydata.push(lv2);
			});

            data2 = res.data.sort(function(a,b){
                return b.total-a.total;
            });
			$.each(data2, function(index, item){
                if (index >= 10){
                    xOther += item.total;
                    return true;
                }
                legend.push(item.name);
                // 频次
                var lv1 = {
                    value: item.total,
                    name : item.name
                };
                xdata.push(lv1);
            });

			// 其它
			if (xOther > 0){
				var temp = {
					value: xOther,
					name : '其它'
				};
				xdata.push(temp);
			}
			if (yOther > 0){
				var temp = {
					value: yOther,
					name : '其它'
				};
				ydata.push(temp);
			}

			drawPie("product_time_pie",ydata, "时长分布");
			drawPie("product_freq_pie",xdata, "频次分布");
		}else{
			$("#product_time_pie").info("暂无数据。",true);
			$("#product_freq_pie").info("暂无数据。",true);
		}
	},false);
}

/**
 * 电视剧题材分析
 */
function getThemeChart(){
	var data = {
			"name" : name,
            "mediaName": mediaName,
            "startDate": $("#start_time").val(),
            "endDate": $("#end_time").val(),
            "theatreTime" : theatreTime
		};
	ajax("ajax_tv_theme.do",data,function(res){
		if(res.code == 1 && res.data.length > 0){
			var legend= [], series = [],xdata = [],ydata = [],zdata = [],html = "", data1=[];
			var xOther = 0;

            avg = res.data[res.data.length - 1];
            // 去掉平均值后在排序
            $.each(res.data, function(index, item){
                if (index < res.data.length - 1) {
                    data1.push(item);
                }
            });
            data1 = data1.sort(function(a,b){
                return b.total-a.total;
            });
			$.each(data1, function(index, item){
			    legend.push(item.firstTheme);
                if (index < 10) {
                    var lv1 = {
                        value: item.total,
                        name : item.firstTheme
                    };
                    xdata.push(lv1);
                }

				if (index >= 10){
					xOther += item.total;
					return true;
				}

			});

			data1 = data1.sort(function(a,b){
                return b.ratio-a.ratio;
            });
            $.each(data1, function(index, item){
                if (index < res.data.length - 1) {
                    ydata.push(item.firstTheme);
                    zdata.push(item.ratio);
                }
            });
            ydata.push(avg.firstTheme);
            zdata.push(avg.ratio);

			// 其它
			if (xOther > 0){
				var temp = {
					value: xOther,
					name : '其它'
				};
				xdata.push(temp);
			}

			drawPie("tvTheme_pie",xdata,"体裁");
            trendBar('收视率',"题材收视",ydata, zdata,'mediaTheme_pie');
		}else{
			$("#tv_group_chart").info("暂无数据。",true);
			$("#net_group_chart").info("暂无数据。",true);
		}
	},false);
}

/**
 * 电视剧及卫视剧场排名
 */
function getRankList(){
	var data = {
			"startDate": $("#start_time").val(),
			"theatreTime":$("#theatreTime").val(),
			"endDate": $("#end_time").val()
		},html="";
	ajax("ajax_topList.do",data,function(res){
		var colors = [];
		if(res.code == 1 && res.data){
			if(res.data.tv && res.data.tv.length > 0){
				var list1 = res.data.tv;
				$.each(list1, function(index, item){
                    html += "<tr class='' data-name='"+item.name+"' data-mediaName='"+item.mediaName+"'>"+
                        "<td>"+(index + 1)+"</td>"+
                        "<td>"+item.name+"</td>"+
                        "<td>"+item.mediaName+"</td>"+
                        "<td>"+item.firstTheme+"</td>"+
                        "<td>"+item.mediaNum+"</td>"+
                        "<td>"+item.rating29+"</td>"+
                        "<td>"+item.dk29+"</td>"+
                    "</tr>";
                });
                $("#rank_char_1").html(html);
			}else{
				$("#rank_char_1").info("暂无数据。");
			}
			var colors2 = [];
			if(res.data.media && res.data.media.length > 0){
			    var list1 = res.data.media;
			    html = "";
				$.each(list1, function(index, item){
                    html += "<tr class='' data-mediaName='"+item.mediaName+"'>"+
                        "<td>"+(index + 1)+"</td>"+
                        "<td>"+item.mediaName+"</td>"+
                        "<td>"+item.mediaRank+"</td>"+
                        "<td>"+item.mediaNum+"</td>"+
                        "<td>"+item.rating29+"</td>"+
                        "<td>"+item.dk29+"</td>"+
                    "</tr>";
                });
                $("#rank_char_2").html(html);
			}else{
				$("#rank_char_2").info("暂无数据。");
			}
			// 电视剧及卫视剧场排名  高亮
			activeTvRank(name, mediaName);
		}else{
			$("#rank_char_1, #rank_char_2").info("暂无数据。");
		}
	},false);
}

function changeTagName(){
	$("span[name='program_tag']").html("《" + name + "》");
	$("span[name='type_tag']").html(mediaName);
	$("span[name='media_tag']").html(mediaName);
	$("span[name='group_title1']").html("广告投放时长分布");
	$("span[name='group_title2']").html("广告投放频次分布");
	$("span[name='net_title1']").html("电视剧体裁结构");
	$("span[name='net_title2']").html("电视剧体裁收视");
}